﻿/*-------------------------------------------------------------------------
 SASEBO_Checker_DES

 File name   : Form_Controller.cs
 Version     : Version 1.0
 Created     : Aug/18/2009
 Last update : Aug/18/2009
 Desgined by : Toshihiro Katashita
 
 
 Copyright (C) 2009 AIST
 
 By using this code, you agree to the following terms and conditions.
 
 This code is copyrighted by AIST ("us").
 
 Permission is hereby granted to copy, reproduce, redistribute or
 otherwise use this code as long as: there is no monetary profit gained
 specifically from the use or reproduction of this code, it is not sold,
 rented, traded or otherwise marketed, and this copyright notice is
 included prominently in any copy made.
 
 We shall not be liable for any damages, including without limitation
 direct, indirect, incidental, special or consequential damages arising
 from the use of this code.
 
 When you publish any results arising from the use of this code, we will
 appreciate it if you can cite our webpage
 (http://www.rcis.aist.go.jp/special/SASEBO/).
 -------------------------------------------------------------------------*/ 

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SASEBO_Checker_DES
{
  //================================================================ Form_Controller
  public partial class Form_Controller : Form
  {
    //************************************************ Variable
    Controller ctrl;
    Random rand;
    int randomseed = 1;

		//************************************************ Method
    //------------------------------------------------ Constructor
    public Form_Controller()
    {
      this.StartPosition = FormStartPosition.Manual;
      InitializeComponent();

      rand = new Random(randomseed);
    }

    //------------------------------------------------ Initialization
    private void Form_Controller_Load(object sender, EventArgs e)
    {
      //form_trace.StartPosition = FormStartPosition.Manual;
      cb_if.SelectedIndex  = 0;
      cb_lsi.SelectedIndex = 0;
      ctrl = new Controller();
      
    }

    //************************************************ Control
    //------------------------------------------------ Button, Start
    private void button_key_Click(object sender, EventArgs e)
    {
      String key_st = "";
      for (int i=0; i<8; i++) key_st += (rand.Next(256)).ToString("X2") + " ";
      tb_key.Text = key_st;
    }

    //------------------------------------------------ Button, Start
    private void button_start_Click(object sender, EventArgs e)
    {
      if (button_start.Text == "Start")
      {
        button_start.Text = "Stop";

        int version = ctrl.module_setup(cb_if.SelectedIndex, cb_lsi.SelectedIndex);
        Console.WriteLine(version.ToString("X4"));

        ctrl.tracer_setup(cb_lsi.SelectedIndex, tbox_numtrace.Text, tb_key.Text);
        ctrl.tracer_addCompletedEventHandler(new RunWorkerCompletedEventHandler(worker_RunWorkerCompleted));
        ctrl.tracer_addProgressChangedEventHandler(new ProgressChangedEventHandler(worker_ProgressChanged));
        ctrl.tracer_run();
      }
      else
      {
        ctrl.tracer_cancel();
      }
    }

    //------------------------------------------------ Menu, Quit
    private void quitToolStripMenuItem_Click(object sender, EventArgs e)
    {
      this.Close();
    }


    //************************************************ BackGroundWorker_EventHandler
    //------------------------------------------------ 
    private void worker_ProgressChanged(object sender, ProgressChangedEventArgs e) {
      label_numtrace.Text = ((TracerReport)e.UserState).num_trace.ToString();

      label_text_in.Text  = format(((TracerReport)e.UserState).text_in);
      label_text_out.Text = format(((TracerReport)e.UserState).text_out);
      label_text_ans.Text = format(((TracerReport)e.UserState).text_ans);
    }

    //------------------------------------------------ 
    private void worker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
    {
/*
      if (!e.Cancelled)
      { // finished
        MessageBox.Show("Finished.", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Information);
      }
      else
      {
        MessageBox.Show("Cancelled.", "Notice", MessageBoxButtons.OK, MessageBoxIcon.Stop);
      }
*/
      button_start.Text = "Start";
    }

 
    //************************************************ 
 		//------------------------------------------------ format()
    private string format(byte[] data)
    {
      string text = "";
      for (int i = 0; i < data.Length; i++) text += String.Format("{0:X2} ", data[i]);
      return text;
    }

  }
}
