﻿/*-------------------------------------------------------------------------
 SASEBO Cipher Module; LSI GAIA(130nm)
 
 File name   : SASEBO_CipherModule.cs
 Version     : Version 1.0
 Created     : Aug/20/2008
 Last update : Jun/11/2009
 Desgined by : Toshihiro Katashita
 
 
 Copyright (C) 2008, 2009 AIST
 
 By using this code, you agree to the following terms and conditions.
 
 This code is copyrighted by AIST ("us").
 
 Permission is hereby granted to copy, reproduce, redistribute or
 otherwise use this code as long as: there is no monetary profit gained
 specifically from the use or reproduction of this code, it is not sold,
 rented, traded or otherwise marketed, and this copyright notice is
 included prominently in any copy made.
 
 We shall not be liable for any damages, including without limitation
 direct, indirect, incidental, special or consequential damages arising
 from the use of this code.
 
 When you publish any results arising from the use of this code, we will
 appreciate it if you can cite our webpage
 (http://www.rcis.aist.go.jp/special/SASEBO/).
 -------------------------------------------------------------------------*/ 

using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace SASEBO
{
	//================================================================ TracerReport
	public struct CipherCore
	{
    public string name;
    public string method;
    public int    id;

		public CipherCore(string name, string method, int id)
		{
			this.name   = name;
			this.method = method;
			this.id     = id;
		}
	}


	//================================================================ CipherModule
	public abstract class CipherModule
	{
		//************************************************ Variable
		// lbus address
  	public int ADDR_VERSION  = 0xFFFC;

    protected LocalBus lbus;

		//************************************************ Method
		//------------------------------------------------ Constructor
		public CipherModule() {}

		//------------------------------------------------ Constructor
		public CipherModule(ControlInterface ctrlif)
		{
			lbus = new LocalBus(ctrlif);
		}
    
		//------------------------------------------------ open()
    public int open()
		{
			int version = lbus.read(ADDR_VERSION);
			return version;
		}

		//------------------------------------------------ close()
		public void close()
		{
			lbus.close();
		}
	}
}
